<!--
Copyright (c) Ryoma Project Contributors

SPDX-License-Identifier: Apache-2.0
-->

(l-main-doc-page)=

# Ryoma documentation

# Introduction

## What is Ryoma?

Ryoma is an AI powered data platform, that helps data users to efficiently use data. Ryoma allows data users to:

* Connect to data sources and ask questions in natural language
* Run on Various Data APIs such as Pandas, Pyarrow, Spark, Pytorch etc.
* Interactively code in Ryoma kernel with AI agent.

**Note:** Ryoma today primarily addresses _data users_.

![](assets/ryoma_marchitecture.png)

## Who is Ryoma for?

Ryoma helps data users with data access and data analysis by leveraging AI. \
Instead of writing code on jupyter notebook, data users can interactively code in Ryoma kernel with AI agent.

## How to get started?


The best way to learn Ryoma is to use it.
Head over to our [Quickstart](https://docs.ryoma.dev/getting-started/quickstart) and try it out!


```{toctree}
:maxdepth: 2

aita-lab/index
architecture/index
contribution/index
getting-started/index
installation/index
reference/index
roadmap/index
tech-specs/index
```